<?php
$width=500;
$height=200;
$marginx=6;
$marginy=6;
$font=3; //Number from 1 to 5
//Set this to the directory where you want the images to be saved.
$savepath='/home/wiserbot/data/WiserBot/web/mods/topten/images/';

//Set this to the path to your mysql.php file.
$path_to_mysql_php='/home/wiserbot/data/WiserBot/common/mysql.php';

//Give me 10 minutes to make the graphs.
set_time_limit(600);
//set_time_limit(10); //Ten seconds for testing, this way if I goof and make an endless loop, don't have to wait long.



//Allow width/height to be overridden by command line arguments or by GET parameters.
if (isset($_GET['gwidth'])){
	$width=$_GET['gwidth'];
}
if (isset($_GET['gheight'])){
	$heigh=$_GET['gheight'];
}
if (isset($_SERVER['argv'][1])){
	$width=$_SERVER['argv'][1];
}
if (isset($_SERVER['argv'][2])){
	$height=$_SERVER['argv'][0];
}


//Allow the person to use the word 'default'.  
//This is useful really only on the command line if you want to change the height, but not the width.
if ($width=='default'){
	$width=400;
}
if ($height=='default'){
	$height=200;
}

if (!function_exists('imagecreate') || !function_exists('imagepng') || !is_writeable($savepath)){
	die('You need to have GD installed and have PNG support enabled.  '.$savepath.' also needs to be writeable.');
}

if ($savepath{strlen($savepath)-1} != '/' && $savepath{strlen($savepath)-1} != '\\'){
	$savepath.='/';
}

include($path_to_mysql_php);

function get_max_chat($arr, $day=false){
	$max=0;
	if ($day===false){
		foreach ($arr as $chan){
			$max+=array_sum($chan);
		}
	}
	else {
		foreach ($arr as $chan){
			$max+=$chan[$day];
		}
	}
	return $max;
}

function get_text_width($txt){
	global $font;
	return strlen($txt)*imagefontwidth($font);
}
function get_text_height(){
	global $font;
	return imagefontheight($font);
}

function DrawBorder($im){
	global $width, $height, $marginx, $marginy;
	$borderxwidth=$marginx/2;
	$borderywidth=$marginy/2;
	$black=imagecolorallocate($im, 0, 0, 0);
	$gray=imagecolorallocate($im, 100, 100, 100);

	ImageFilledRectangle($im, $width-$borderxwidth, 0, $width, $height, $black);
	ImageFilledRectangle($im, 0, $height-$borderywidth, $width, $height, $black);
	ImageFilledRectangle($im, 0, 0, $borderxwidth, $height, $gray);
	ImageFilledRectangle($im, 0, 0, $width, $borderywidth, $gray);
}

function DrawXAxis($im, $total, $steps=9){
	global $width, $height, $marginx, $marginy, $font;
	$dkblue=imagecolorallocate($im, 50, 50, 155);
	$blue=imagecolorallocate($im, 0, 0, 255);
	$gray=imagecolorallocate($im, 150, 150, 150);
	$textwidth=0;
	$textheight=get_text_height();
	
/*
	$count=0;
	if ($max > $steps){
		if ($max >= 1024){
			$label='Kb';
			$max=round($max/1024, 2);
		}
		else {
			$label='b';
		}
		$inc=round($max/$steps, 2);
		$steps=1;
		$ltext='';
		while ($count<=$max){
			$steps++;
			$count+=$inc;
			if (strlen($count.$label) > strlen($ltext)){
				$ltext=$count.$label;
			}
		}
		$textwidth=get_text_width($ltext);
	}
	else {
		$steps=1;
		$inc=1;
		$textwidth=get_text_width('0b');
	}

	$x=$marginx+$textwidth;
	$y=$marginy+$textheight;

	ImageLine($im, $x, $y, $x, $height-$y, $dkblue);

	//$textheight*=2;
	
	$count=0;
	$x=$marginx;
	$y=$height-($marginy+$textheight);
	while ($y > 0 && $count <= $max){
		$imlabel=$count.$label;
		imageline($im, $x+$textwidth-10, $y, $width-$x, $y, $gray);
		imagestring($im, $font, $x+($textwidth-get_text_width($imlabel))-2, $y-($textheight/2), $imlabel, $blue);
		$y=$y-(($height+$marginy)/$steps-2);
		$count+=$inc;
	}
	$y=$y+(($height-$marginy)/$steps);
*/
	//Lets try a new approch.  I'll to x steps, each step will be that percent of the total.
	//Eg. 10 steps, first step == 10%, second step==20%, third step==30%
	//Eg.  4 steps, first step == 25%, second step==50%, third step==75%

	$debugColor=imagecolorallocate($im, 255, 200, 0);
	$percentInc=1/$steps;
	$i=0;
	$ltext='';
	$label='';
	$count=0;
	$y=0;
	$x=10;
	$miny=$marginy+$textheight;
	$areaheight=$height-($marginy+$textheight);


	if ($total>= 1024){
		$label='Kb';
		$total=round($total/1024, 2);
	}
	else {
		$label='b';
	}

	//echo '$steps=', $steps, '; $percentInc=', $percentInc, '; 2$percentInc=', 1*$percentInc, '; $count=', 1*$percentInc*$total, "\n";
	while ($i<=$steps){
		$count=$i*$percentInc*$total;
		$count=round($count, 2);
		if (strlen($count.$label) > strlen($ltext)){
			$ltext=$count.$label;
		}
		$i++;
	}

	$textwidth=get_text_width($ltext);
	//echo 'ltext: ', $ltext, '; $textwidth=', $textwidth, ";\n";
	$x=$marginx;

	imagerectangle($im, $x+$textwidth, $miny, $width-$marginx, $areaheight, $debugColor);
	$i=0;
	$count=0;
	while ($i<=$steps){
		$count=$i*$percentInc*$total;
		$count=round($count, 2);
		$y=($areaheight)-($i*$percentInc*($areaheight-$miny));

		//echo '$steps=', $steps, '; $percentInc=', $percentInc, '; $i=', $i, '; $count=', $count, '; $total=', $total, '; $y=', $y, "\n";
		$imlabel=$count.$label;
		imageline($im, $x+$textwidth-10, $y, $width, $y, $gray);
		imagestring($im, $font, $x+($textwidth-get_text_width($imlabel)), $y-$textheight/2, $imlabel, $blue);
		$i++;
	}

	imageline($im, $x+$textwidth, $miny, $x+$textwidth, $areaheight, $dkblue);

	return $textwidth;
}

function DrawYAxis($im, $labels, $textwidth){
	global $width, $height, $marginx, $marginy, $font;
	$dkblue=imagecolorallocate($im, 50, 50, 155);
	$blue=imagecolorallocate($im, 0, 0, 255);
	$textheight=get_text_height();

	$x=$marginx+$textwidth;
	$y=$height-($marginy+$textheight);

	ImageLine($im, $x, $y, $width-$x+$textwidth, $y, $dkblue);

	$starts=array();
	$count=count($labels);
	$inc=($width)/$count;
	$inc+=5*$count;
	for ($k=0; $k<$count; $k++){
		$label=$labels[$k];
		$len=get_text_width($label);
		$starts[$label]=$x;
		ImageString($im, $font, $x, $y, $label, $blue);
		$x+=get_text_width($label)+($inc/$count);
	}
	return $starts;
}

function DrawBar($im, $chan, $single, $total, $x, $color, $bgcolor){
	global $width, $height, $marginx, $marginy, $font;
	if ($total==0){
		$single=0; $total=1;
	}

	$textheight=get_text_height();

	$miny=$marginy+$textheight;
	$areaheight=$height-($marginy+$textheight);
	$y=$height-($marginy+$textheight);
	$barheight=floor(($single/$total)*($areaheight-$miny));
	$barwidth=get_text_width($chan)/2;
	$bartop=$y-$barheight;

	if ($bartop < $miny){
		$bartop=$miny;
	}
	$label='b';
	if ($single > 1024){
		$single/=1024;
		$single=round($single, 2);
		$label='Kb';
	}
	$label=$single.$label;
	ImageFilledRectangle($im, ($x+$barwidth/2)+1, $bartop-1, ($x+$barwidth*1.5)+1, $y-1, $bgcolor);
	ImageFilledRectangle($im, $x+$barwidth/2, $bartop, $x+$barwidth*1.5, $y, $color);

	$labelsize=get_text_width($label);
	if ($labelsize > $barwidth && $labelsize-$barwidth > 5){
		//echo 'Label for is larger than bar.', "\n";
		$x-=$barwidth/get_text_width($label);
	}
	else if ($labelsize < $barwidth && $barwidth-$labelsize > 5){
		//echo 'Label for is smaller than bar.', "\n";
		//This will get x to the edge of the bar.
		$x+=$barwidth/2;
		//This will put the staring point in the middle of the bar (or close to)
		$x+=($barwidth-get_text_width($label))/2;
	}
	else {
		//echo 'Label and bar size are almost equal.', "\n";
		$x+=$barwidth/2;
		$x+=max($labelsize, $barwidth)-min($labelsize, $barwidth);
	}
	ImageString($im, $font, $x, $bartop-get_text_height()-6, $label, $color);
}

///Connect to mysql
db_connect(MYSQL_HOST, MYSQL_UNAME, MYSQL_PWORD, MYSQL_DB);

$res=db_query("SELECT DISTINCT NickID FROM mod_topten ORDER BY NickID");
if (!$res){
	die("Unable to select data");
}
$rows=db_num_rows($res);
$i=0;
$date=date('w');
while ($i<$rows){
	$NickID=db_result($res, $i, 'NickID');

	//Get the channeals and chat counts they have been on.
	$nickres=db_query("SELECT Chan, Chat0, Chat1, Chat2, Chat3, Chat4, Chat5, Chat6 FROM mod_topten WHERE NickID='{$NickID}'");
	if (!$nickres || db_num_rows($res)==0){
		echo 'Unable to get stats for ', $NickID, "\n";
		continue;
	}

	//Read it all into an array for easy an easy reference.
	$nickarr=array();
	while ($row=db_get_row($nickres)){
		$nickarr[$row->Chan]=array($row->Chat0, $row->Chat1, $row->Chat2, $row->Chat3, $row->Chat4, $row->Chat5, $row->Chat6);
	}
	echo 'Making Daily graph for ', $NickID, '(', $i, ')', "\n";

	$im=ImageCreate($width, $height);

	$offwhite=imagecolorallocate($im, 220, 220, 220);
	$fg=imagecolorallocate($im, 30, 100, 30);
	$bg=imagecolorallocate($im, 0, 0, 0);

	//Drawing daily graph now.
	ImageFill($im, 0, 0, $offwhite);
	$total=get_max_chat($nickarr, $date);
	$txtwidth=DrawXAxis($im, $total);
	$starts=DrawYAxis($im, array_keys($nickarr), $txtwidth);
	foreach ($nickarr as $chan=>$data){
		//echo 'Drawing bar for ', $chan, "\n";
		DrawBar($im, $chan, $data[$date], $total, $starts[$chan], $fg, $bg);
	}
	DrawBorder($im);
	ImagePNG($im, $savepath.$NickID.'.png');
	//ImagePNG($im); //Just for testing.

	ImageDestroy($im);

	//exit; //Just for testing.
	echo 'Making Weekly graph for ', $NickID, '(', $i, ')', "\n";
	//Now we make the weekly image.
	$im=ImageCreate($width, $height);

	$offwhite=imagecolorallocate($im, 220, 220, 220);
	$fg=imagecolorallocate($im, 30, 100, 30);
	$bg=imagecolorallocate($im, 0, 0, 0);

	ImageFill($im, 0, 0, $offwhite);

	$total=get_max_chat($nickarr);

	$txtwidth=DrawXAxis($im, $total);
	$starts=DrawYAxis($im, array_keys($nickarr), $txtwidth);
	foreach ($nickarr as $chan=>$data){
		//echo 'Drawing bar for ', $chan, "\n";
		DrawBar($im, $chan, array_sum($data), $total, $starts[$chan], $fg, $bg);
	}
	DrawBorder($im);
	ImagePNG($im, $savepath.$NickID.'w.png');
	//header('Content-type: image/png'); //Just for testing.
	//ImagePNG($im);
	ImageDestroy($im);
	
	$i++;
}

?>
